<template>
  <!-- 查询和其他操作 -->
  <div class="filter-container" style="margin: 10px 0 10px 0;">
    <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
      <el-form-item label="用户ID">
        <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.openId" placeholder="请输入" />
      </el-form-item>
      <el-form-item label="瓦力ID">
        <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.uid" placeholder="请输入" />
      </el-form-item>
      <el-form-item label="事由">
        <el-select v-model="queryParams.actType" placeholder="事由"  class="filter-item" style="width: 200px;">
          <el-option label="全选" value=""></el-option>
          <el-option label="登录赠币" value="FIRSTLOGINPRE">登录赠币</el-option>
          <el-option label="绑定手机赠币"  value="BINDPHONEPRE">绑定手机赠币</el-option>
          <el-option label="会员赠币" value="VIPLEVELPRE">会员赠币</el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="用户来源">
          <el-select
            v-model="queryParams.source"
            class="filter-item"
            placeholder="用户来源"
            style="width: 140px"
            filterable
            clearable
            remote
            reserve-keyword
          >
            <el-option
              v-for="item in sourceData"
              :key="item.source"
              :label="item.name"
              :value="item.source"
            ></el-option>
          </el-select>
      </el-form-item>
      <el-form-item label="日期时间">
        <el-date-picker
          v-model="queryParams.beginCreateTime"
          type="datetime"
          placeholder="开始日期"
          class="baseInput"
          format="yyyy-MM-dd HH"
          value-format="yyyy-MM-dd HH"
          style="width: 200px;"
        >
        </el-date-picker>
        <span> - </span>
        <el-date-picker
          v-model="queryParams.endCreateTime"
          type="datetime"
          placeholder="结束日期"
          class="baseInput"
          format="yyyy-MM-dd HH"
          value-format="yyyy-MM-dd HH"
          style="width: 200px;"
        >
        </el-date-picker>
      </el-form-item>
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">搜寻</el-button>
      <el-button class="filter-item" type="primary" icon="el-icon-s-flag" @click="exportData">导出</el-button>
    </el-form>
    <el-table :data="tableData" style="width:100%" class="show_table" >
      <el-table-column label="用户ID" style="width:10%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.openId }}</span>
        </template>
      </el-table-column>
      <el-table-column label="用户来源" style="width:15%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.sourceName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="瓦力ID" style="width:10%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.cusUid }}</span>
        </template>
      </el-table-column>
      <el-table-column label="获得赠币数" style="width:10%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.actPreAmount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="事由" style="width:5%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.actType == 'FIRSTLOGINPRE'">登录赠币</span>
          <span v-if="scope.row.actType == 'VIPLEVELPRE'">会员赠币</span>
          <span v-if="scope.row.actType == 'BINDPHONEPRE'">绑定手机赠币</span>
        </template>
      </el-table-column>
      <el-table-column label="时间" style="width:6%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>
    </el-table>
    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>
  </div>
</template>
<script>
  import {dateFormat} from "@/utils/webUtils.js";
  import {getActRecordList,getSourceList} from "@/api/gameActRecords";
  import {
    export_json_to_excel
  } from "@/vendor/Export2Excel";
  export default {
    data() {
      return {
        sourceData: [
          {
            name:'全选',
            source:''}
        ],
        queryParams:{//查询参数
          openId: "", //用户ID
          beginCreateTime: dateFormat("YYYY-mm-dd 00", new Date()),
          endCreateTime: dateFormat("YYYY-mm-dd 23", new Date()),
            actType: "", //订单状态
          source: "",
        },
        tableData: [],
        currentPage: 1,
        pageSize: 40,
        total: 0, //总数量
        orderByDescColumn: "", // 降序字段
        orderByAscColumn: "", // 升序字段
        form: {
          content: "",
          introduce: "",
          sort: 0,
        },
      };
    },
    created() {
      this.orderWithRequestList();
      this.sourceList();
    },
    methods: {
      sourceList: function() {
        var sourceParams = {};
        sourceParams.pageSize = 1000;
        sourceParams.currentPage = 1;
        getSourceList(sourceParams).then(response => {
          this.sourceData.push(...response.data.records);
        });
      },
      orderWithRequestList: function() {
        this.queryParams.currentPage = this.currentPage;
        this.queryParams.pageSize = this.pageSize;
        this.queryParams.orderByDescColumn = this.orderByDescColumn
        this.queryParams.orderByAscColumn = this.orderByAscColumn
          getActRecordList(this.queryParams).then(response => {
          this.tableData = response.data.records;
          this.currentPage = response.data.current;
          this.pageSize = response.data.size;
          this.total = response.data.total;
        });
      },
      getFormObject: function() {
        var formObject = {
          uid: null,
          content: null,
          clickCount: 0,
          sort: 0
        };
        return formObject;
      },
      handleFind: function() {
        this.currentPage = 1
        this.orderWithRequestList();
      },
      handleSizeChange(val) {
        this.pageSize = val;
        this.orderWithRequestList();
      },
      handleCurrentChange: function(val) {
        this.currentPage = val;
        this.orderWithRequestList();
      },
      handleSelectionChange(val) {
        this.multipleSelection = val;
      },
      handleClose(){
        this.dialogFormVisible = false;
        this.orderWithRequestList();
      },
      // 导出excel数据
      exportData() {
        // 表头对应关系
        const headers = {
          '用户ID': 'openId',
          '用户来源': 'sourceName',
          '瓦利ID': 'cusUid',
          '获得赠币数': 'actPreAmount',
          '事由': 'actType',
          '时间': 'createTime',
        }
        this.queryParams.currentPage = 1;
        this.queryParams.pageSize = -1;
        this.queryParams.orderByDescColumn = this.orderByDescColumn
        this.queryParams.orderByAscColumn = this.orderByAscColumn
        getActRecordList(this.queryParams).then(response => {
          const data = this.formatJson(headers, response.data.records)
          export_json_to_excel(Object.keys(headers), data, '活动赠币记录')
        });
      },
      // 该方法负责将数组转化成二维数组
      formatJson(headers, rows) {
        // 首先遍历数组
        return rows.map(item => {
          return Object.keys(headers).map(key => {
            if (headers[key] === 'actType') {
              if(item[headers[key]] === 'FIRSTLOGINPRE'){
                return '登录赠币';
              } else if(item[headers[key]] === 'VIPLEVELPRE') {
                return '会员赠币';
              } else if(item[headers[key]] === 'BINDPHONEPRE'){
                return '绑定手机赠币';
              }
            }
            return item[headers[key]]
          })
        })
      },
    }
  };
</script>
<style scoped>
</style>
